--[[We will keep track of every sign built in table (global.signs)
signs built by robots won't have any messages
the sign should not be deconstructible by robots
the sign should be invincible and non-colliding
]]--[[
on entity built we'll
check whether it's our sign
if it is, we'll add it to the intermediate table (global.last_sign) and create gui for deciding its fate
]]--[[
the gui will have cancel and place buttons
]]--[[
the place button will 
spawn flying text entity and set it inactive, so it would stay forever
set sign indestructible
store the entities of sign and text as well as the string typed in (global.signs)
]]--[[
the cancel button will
delete intermediate variables
close the gui
]]--[[
on entity mined we'll 
see if it's sign removed
accompanying text will be destroyed
string will be placed in intermediate table
position will be placed in intermediate table
the gui with previously typed message will be provided
if place button is pressed, we'll check wheter player has a signpost in inventory
remove that
spawn new sign entity along with flying text
clear all intermediate variables
]]

require "defines"
require "util"


function init() 
    global.signs=global.signs or {}
    global.last_built=global.last_built or {}
    global.last_pos=global.last_pos or {}
    global.last_str=global.last_str or {}
end
script.on_init(function() init() end)
--game.on_load(function() init() end)

function draw_gui(player_index)
    if game.players[player_index].gui.center.SignPosts then
        game.players[player_index].gui.center.SignPosts.destroy()
    end
    game.players[player_index].gui.center.add{type="frame", name="SignPosts", caption={"gui-main-caption"}, direction="vertical"}
    root=game.players[player_index].gui.center.SignPosts
    root.add{type='textfield',name='message'}
    root.add{type="button", name="spwrite", caption={"gui-button-write"}}
    root.add{type="button", name="spcancel", caption={"gui-button-cancel"}}
    if global.last_str[player_index] then
        root.message.text=global.last_str[player_index] 
    end
end

script.on_event(defines.events.on_gui_click,
    function(event)
        if event.element.parent.name=='SignPosts' then
            if event.element.name=="spwrite" then--Write button
                if global.last_built[event.player_index]==nil then--Rebuilding signpost
                    if game.players[event.player_index].get_item_count('sign-post')>0 then
                        global.last_built[event.player_index]=global.last_pos[event.player_index].surf.create_entity{
                            name='sign-post',
                            position=global.last_pos[event.player_index].pos,
                            force=game.players[event.player_index].force,
                            }
                    else
                        game.players[event.player_index].print({'gui-error-msg'})
                        return
                    end--if get_item_count('sign-post')>0
                end--if global.last_built[event.player_index]!=nil
                local tempos=global.last_built[event.player_index].position
                local temp=global.last_built[event.player_index].surface.create_entity{
                            name='flying-text',
                            position={tempos.x-1,tempos.y-1},
                            force=game.players[event.player_index].force,
                            text=event.element.parent.message.text,
                            }
                temp.active=false
                global.last_built[event.player_index].destructible=false
                table.insert(global.signs,{sign=global.last_built[event.player_index],text=temp,str=event.element.parent.message.text})
                event.element.parent.destroy()
                global.last_built[event.player_index]=nil
                global.last_pos[event.player_index]=nil
                global.last_str[event.player_index]=nil
            elseif event.element.name=="spcancel" then--Cancell button
                event.element.parent.destroy()
                global.last_built[event.player_index]=nil
                global.last_pos[event.player_index]=nil
                global.last_str[event.player_index]=nil
            end--if event.element.name=="spwrite elseif event.element.name=="spcancel"
        end--if event.element.parent.name=='SignPosts'
    end)

script.on_event(defines.events.on_built_entity,
    function(event)
        if event.created_entity.name=='sign-post' then
            --event.created_entity.destructible=false
            --table.insert(global.signs,{sign=event.created_entity})
            global.last_built[event.player_index]=event.created_entity
            draw_gui(event.player_index)
        end
    end)
    
script.on_event(defines.events.on_preplayer_mined_item,
    function(event)
        if event.entity.name=='sign-post' then
            i=1;
            while i<=#global.signs and not(event.entity==global.signs[i].sign) do
                i=i+1;
            end
            if i<=#global.signs then
                global.signs[i].text.destroy();
                global.last_str[event.player_index]=global.signs[i].str
                table.remove(global.signs,i); 
            end
            draw_gui(event.player_index)
            global.last_pos[event.player_index]={pos=event.entity.position, surf=event.entity.surface}
        end
    end)

script.on_event(defines.events.on_marked_for_deconstruction, 
    function(event)
        if event.entity.name=='sign-post' then
            event.entity.cancel_deconstruction(event.entity.force)
        end
    end)
